library ieee;
use ieee.std_logic_1164.all;


entity count_ones is
	port
	(
		clk:		in 	std_logic;
		
		data:		in		std_logic_vector;  -- ab VHDL2008: unbestimmter range
		count: 	out	natural
	);
end;


architecture mfm of count_ones is

begin

	process(clk)
		variable cnt: natural range 0 to data'length;
	begin
		if rising_edge(clk)
		then
			cnt := 0;
			for i in data'range		-- optionaler durchlaufbereich
			loop							-- hier loop begin
				if data(i)
				then
					cnt := cnt +1;
				end if;
			end loop;					-- hier loop end
			count <= cnt;
		end if;
	end process;

end;