library ieee;
use ieee.std_logic_1164.all;

package helpers is

	component count_ones is
		port
		(
			clk:	in std_logic;
			
			data:	in	std_logic_vector;
			count: out	natural
		);
	end component;

	function countones (data: std_logic_vector) return natural;

end package;

package body helpers is

	function countones (data: std_logic_vector) return natural is
			variable cnt: natural range 0 to data'length := 0;
	begin
		
		for i in data'range
		loop
			if data(i) 
			then
				cnt := cnt +1;
			end if;
		end loop;

		return cnt;
	end function;

end package body;